/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.rich.functionsample.controllerex.view;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.core.io.FileSystemResourceLoader;
import org.springframework.core.io.Resource;
import org.springframework.util.StringUtils;
import jp.terasoluna.fw.web.rich.springmvc.Constants;
import jp.terasoluna.fw.web.rich.springmvc.servlet.view.filedownload.AbstractFileDownloadView;
import jp.terasoluna.rich.functionsample.controllerex.bean.ControllerExFileData;

/**
 * コントローラ拡張のファイルダウンロードビュークラス
 *
 */
public class ControllerExFileView extends AbstractFileDownloadView {
    /**
     * レスポンスに設定する、コンテンツタイプのキー。
     */
    protected String contentTypeKey = "Content-Disposition";
    
    /**
     * レスポンスに設定する、コンテンツタイプのプリフィックス。
     */
    protected String contentTypePrefix = "attachments;filename=";
    
    /**
     * 入力ストリームを取得する。
     * @param model 業務ロジックの結果。
     * @param request HTTPリクエスト。
     * @return 入力ストリーム。
     * @throws IOException 入出力例外。
     */
    @Override
    protected final InputStream getInputStream(
            Map model, HttpServletRequest request) throws IOException {
        
        // リソースを取得
        Resource resource = getResource(getFileDownloadModel(model), request);
             
        try {
            return resource.getInputStream();
        } catch (IOException e) {
            throw e;
        }
    }

    /**
     * ダウンロード対象のリソースを取得する。
     * ファイルパスで表現されるリソースを取得する。
     * ファイル名が設定されていない場合、例外が発生する。
     * @param fdlModel ControllerExFileDataインスタンス。
     * @param request HTTPリクエスト。
     * @return ダウンロード対象のリソース。
     * @throws IOException 入出力例外。
     */
    protected Resource getResource(
            ControllerExFileData fdlModel, HttpServletRequest request) 
            throws IOException {
        if (fdlModel == null) {
            throw new IllegalArgumentException(
                    "FileResponseOutputData is null!");
        }
        
        if (fdlModel.getDirectoryName() == null) {
            throw new IllegalArgumentException("DirectoryName is Empty.");
        }
        
        if (!StringUtils.hasText(fdlModel.getFileName())) {
            throw new IllegalArgumentException("FileName is Empty.");
        }
        
        // ファイルパス
        String location = fdlModel.getDirectoryName() + File.separator
            + fdlModel.getFileName(); 
        
        // リソースの読みこみ
        return new FileSystemResourceLoader().getResource(location);
    }

    /**
     * モデルオブジェクトからFileDownloadModelインスタンスを取得する。
     * @param model 業務ロジックの結果。
     * @return ControllerExFileDataクラス
     */
    protected ControllerExFileData getFileDownloadModel(Map model) {
        Object result = model.get(Constants.RESULT_KEY);
        if (result == null) {
            throw new IllegalStateException(
                    "FileResponseOutputData Object is Null.");
        }
        
        // 本クラスを使用する場合、業務ロジックにてFileDownloadModelを返さなくてはならない。
        if (!(result instanceof ControllerExFileData)) {
            throw new IllegalArgumentException(
                    "FileDownloadView must use FileResponseOutputData class!");
        }
        return (ControllerExFileData) result;
    }

    /**
     * レスポンスヘッダを追加する。
     * @param model 業務ロジックの結果。
     * @param request HTTPリクエスト。
     * @param response HTTPレスポンス。
     */
    @Override
    protected final void addResponseHeader(Map model, 
            HttpServletRequest request, HttpServletResponse response) {
        
        // レスポンスヘッダに設定するキーと値のセットを取得する
        Map<String, String> headerMap = 
            createResponseHeaderMap(getFileDownloadModel(model), request);
        
        for (String key : headerMap.keySet()) {
            response.addHeader(key, headerMap.get(key));
        }
    }
    
    /**
     * レスポンスヘッダに追加するキーと値を、Map形式で作成する。
     * @param fdlModel 業務ロジックにて返されるFileDownloadModelインスタンス。
     * @param request HTTPリクエスト。
     * @return レスポンスヘッダに追加するキーと値のMap。
     */
    protected Map<String, String> createResponseHeaderMap(
            ControllerExFileData fdlModel, HttpServletRequest request) {
        Map<String, String> headerMap = new HashMap<String, String>();
        
        // コンテンツタイプ
        headerMap.put(contentTypeKey, 
                contentTypePrefix + fdlModel.getFileName());
        return headerMap;
    }
}
